/*********************************************************************

              XBee ԊOR for PIC12F683

{\[XXgу\tgEFÁACZXt[łB
lł̗p͎Rɍs܂B쌠\̉ς͋֎~܂B

                               Copyright (c) 2012 Wataru KUNINO
                               http://www.geocities.jp/bokunimowakaru/
*********************************************************************/
/*
gp@

VA(9600 8-N-1)ŎMMԊORMɕϊđM܂B

MtH[}bg ()16i\L̃R[h

		1       2       3       4       5       6    ..... 10
		ESC(1B) I(49)   R(52)   len(06) d[0]    d[1] ..... d[5]

		1`3oCgڂ͐ԊORM̎ʎq
		4oCgڂ̓RR[h̃TCYioCgj
			AA2bit̓RR[h̃^CvB
				0=AEHA(00)  1=NEC(40) 2= SIRC(80)  3=vZbg(C0)
			vZbg4oCgڂ̉4bitvZbgԍ(0`15)
		5oCgڈȍ~̓RR[h
		
		SHARPer̃{[_EM𑗐Mꍇ̗
		1B 49 52 06 AA 5A 8F 12 15 E1
		
		vZbg0ԂRMꍇ̗
		1B 49 52 C0
		
		vZbgMEEPROM֏LMtH[}bg4oCgڂ
		o^B
		vZbg͍ő16B
		P̃vZbgM͍ő15oCgB
		EEPROM̃AhX16oCgɃvZbgԍ0`15Ԃ܂

񎖍
		RM8rbgPʂňĂ܂B
		SIRCȂǂ8rbgPʂɂȂȂꍇ͑Mł܂B

Ql

{\tg̊Ĵ߂ɉL̕Qlɂ܂B

EMICROCHIP PIC12F683 Data Sheet (DS41211D) 2007
	Microchip Technology Inc.
ECł͂߂PIC}CRiI[Ёj
	^
EvgōPICpuigYj
	ؓN
EArduino͂߂悤 (IC[Wp)
	Massimo Banzi Dc
EArduino {ꃊt@X
	http://www.musashinodenpa.com/arduino/ref/index.php
*/

#include <htc.h>
    __CONFIG(INTIO & WDTDIS & PWRTEN & MCLRDIS & UNPROTECT & BORDIS & IESODIS & FCMDIS);

typedef unsigned char byte;

#define _XTAL_FREQ	8000000	
#define PS_IN		GPIO3			// p[Z[up̒[q(IOC)
#define T0_COUNT	247				// timer0 JEg̏l(13us)
#define T0_COUNT_L	247				// timer0 JEg̏l(13us)
#define VCC			40				// ͓d(10{V)
#define SCIF_RX		GPIO1			// GPIO1= UART_RX
#define SCIF_TX		GPIO0			// GPIO0= UART_TX
#define SCIF_TMADD	26				// 9600bps  104.16us -> 26.0
#define LED			GPIO5			
#define LED_OFF		1				// ʏLED񔭌̏o͒l
#define LED_ON		0				// ʏLED̏o͒l

#define IR_OUT		GPIO4			// ԊOLED̐ڑ|[g
#define IR_OUT_OFF	0				// ԊOLED񔭌̏o͒l
#define IR_OUT_ON	1				// ԊOLED̏o͒l
#define DATA_SIZE	16				// f[^(byte),4̔{A16ȏ
//  DATA_SIZE ̕ύX RguDATA_SIZE = 16pv̕ύXKv)

#define FLASH_AEHA_TIMES	16	// V{̔g_ŉ񐔁i`dg`j
#define FLASH_NEC_TIMES		22	// V{̔g_ŉ񐔁imdbj
#define FLASH_SIRC_TIMES	24	// V{̔g_ŉ񐔁irhqbj

enum IR_TYPE{ AEHA=0, NEC=1, SIRC=2 };	

/* |[gݒ */
void init_io(void){
	OSCCON  = 0b01110000;	// Clock =8MHz
	
	// PIC12F683
	// 		pin 1	Vcc
	// 		pin 2	GPIO5 LED
	// 		pin 3	GPIO4 ԊOMo
	// 		pin 4	GPIO3 PS_IN (IOC)
	// 		pin 5	GPIO2 IRZT(p)
	// 		pin 6	GPIO1 SCI_RX VA
	// 		pin 7	GPIO0 SCI_TX VAo (eXgp)
	// 		pin 8	GND

	GPIO    = 0b00000001;	// o͒l
	CMCON0  = 0b00000111;	// Comparator Off
	ANSEL   = 0x00;			// ADC Off
	GPPU    = 0;	// bit 0 = GPIO Pull-up Enable  1 = disabled
	WPU0    = 0;	// bit 1 = pull up
	WPU1    = 1;	
	WPU2    = 1;	
//	WPU3    = 1;
	WPU4    = 0;	
	WPU5    = 0;
	TRISIO0 = 0;	// SCI_TX 0 = output
	TRISIO1 = 1; 	// SCI_RX 1 = input
	TRISIO2 = 1;	// IRZT
//	TRISIO3 = 1;	// PS_IN (IOC) inputŒ
	TRISIO4 = 0;	// ԊOMo
	TRISIO5 = 0;	// LED

	IOC		= 0b00001000;	// GPIO荞
	//		      |____|______ IOC5...IOC0
	GPIE = 0;	// GPIO̊荞݂Off
	GPIF = 0;	// tÕZbg
}

/* ^C}[ݒ */
//	timer0	gJEgp
//	timer1	SCIɎgp(scif.c)
//	timer2	gp

void init_t0(void){
	// TIMER0 for g 26us 13usOn/Off
	OPTION = 0b01000000;	// configure Timer0
	//         ||  ||_|___________ PSx 1/2=000 1/4=001 ... 1/256=111
	//         ||  |______________ PSA PS TimerŎg=0AWDTŎg=1
	//         ||_________________ EDGE 0=rising 1=fall
	//         |__________________ GPPU week pull up enable = 0
	//
	// f_clock/4 (2MHz) ɃvXP[PS=1/2 ɂ 1000kHz(1us)
	
	TMR0 = T0_COUNT;		// ^C}[0̃JE^ɏl
	T0IF = 0;				// ensure Timer0 Interrupt flag is clear
	T0IE = 0;				// disable Timer0 interrupts
}

void scif_init(void){
	CMCON0 = 0b00000111;	// Rp[^sgp
	SCIF_TX = 1;
	
	// TIMER1 16bit
	// Fosc/4 = 2MHz	(TMR1CS=0)
	T1CON =  0b00110001;
	//         00||00||____ TMR1ON(1=Enable)
	//           ||  |_____ TMR1CS: Timer1 Clock Source (0:Internal)
	//           ||________ Prescale 00(1/1)`11(1/8)
	//						250kHz -> 4us

	TMR1L = 0x00;
	TMR1H = 0x00;
	TMR1IF = 0;			// tONA
	TMR1IE = 0;			// 荞ݐݒ肵Ȃ
	while( TMR1L < SCIF_TMADD );
}

void putch(const unsigned char c){
	byte i;
	
	TMR1H = 0x00;
	TMR1L = 0x01;
	TMR1IF = 0;
	while( TMR1L < SCIF_TMADD );
	asm("NOP");
	asm("NOP");
	TMR1L = 0x01;
	SCIF_TX = 0;	// rs`qsrbgM
	for( i= 0 ; i < 8 ; i++ ){
		while( TMR1L < SCIF_TMADD );
		asm("NOP");
		asm("NOP");
		TMR1L = 0x01;
		SCIF_TX = ( ( c >> i ) & 0x01);
	}
	while( TMR1L < SCIF_TMADD );
	asm("NOP");
	asm("NOP");
	TMR1L = 0x01;
	SCIF_TX = 1;	// rsnorbgM
	while( TMR1L < SCIF_TMADD );
}

void puts(const unsigned char *s){
	while( *s ){
		putch( *s++ );
	}
}

/* 16ȉo */
void puts_hex(const unsigned char i){
    unsigned char out;
    out=i&0xF0;               // High nibble
    out=out>>4;
    out=out+'0';
    if (out>'9'){
        out+=7;
	}
    putch((char)out);
    out=(i&0x0F)+'0';         // Low nibble
    if (out>'9'){
        out+=7;
	}
    putch((char)out);
}

byte getch( void ){
	byte i;
	byte c = 0x00;
	
	TMR1H = 0x00;
	TMR1L = 0x01;
	TMR1IF = 0;
	while( SCIF_RX == 1 && TMR1IF == 0 );	// STARTrbg҂ or 260ms҂
	if( SCIF_RX == 0 ){
		TMR1L = 0x01;
		while( TMR1L < ( SCIF_TMADD / 2 ) );	// rbg҂
		TMR1L = 0x01;
		for( i= 0 ; i < 8 ; i++ ){
			while( TMR1L < SCIF_TMADD );		// 1rbg҂
			TMR1L = 0x01;
			c |= ((byte)SCIF_RX) << i;
		}
		while( TMR1L < SCIF_TMADD );		// 1rbg҂
		if( SCIF_RX == 0 ) c =0x00;			// STOPrbg񌟏o
	}
	return( c );
}

void sleep_on(void){
	IR_OUT = IR_OUT_OFF;
	di();					// disable global interrupts
	GPIF = 0;	// tÕZbg
	GPIE = 1;	// GPIO̊荞݋N̐ݒ
	GIE  = 1;
	ei();					// enable global interrupts

	asm("SLEEP");
	asm("NOP");
	GPIE = 0;				// GPIO̊荞݂Off
	GPIF = 0;				// tÕZbg
	di();					// disable global interrupts
	init_io();
	scif_init();					// VA

	IR_OUT = IR_OUT_OFF;
}

/* ݏ */
void interrupt interrupt_service(void){
	if( TMR1IF ) TMR1IF = 0;		// SCIp̃^C}[P̃tÕNA
	if( GPIE && GPIF ){
		GPIE = 0;
		GPIF = 0;
	}
}
/* ԊOkdc_ŗp(^C}[p) */
void ir_flash(byte times){
	while(times){
		times--;
		while( !T0IF );
		TMR0 = T0_COUNT;		// 4JEgx+9JEg= 13us
		T0IF = 0;
		IR_OUT = IR_OUT_ON;
		while( !T0IF );
		TMR0 = T0_COUNT_L;		// 4JEgx+9JEg= 13us
		T0IF = 0;
		IR_OUT = IR_OUT_OFF;
	}
}
void ir_wait(byte times){
	while(times){
		times--;
		while( !T0IF );
		TMR0 = T0_COUNT;
		T0IF = 0;
		IR_OUT = IR_OUT_OFF;
		while( !T0IF );
		TMR0 = T0_COUNT_L;
		T0IF = 0;
		IR_OUT = IR_OUT_OFF;
	}
}

/* ԊOkdcMo */
void ir_send(byte *data, const byte data_len, const enum IR_TYPE ir_type ){
	byte i,j,t;
	byte b;
	byte out;
	
	switch( ir_type ){
		case NEC:
			ir_flash( 8 * FLASH_NEC_TIMES );	// send 'SYNC_H'
			ir_flash( 8 * FLASH_NEC_TIMES );
			ir_wait(  8 * FLASH_NEC_TIMES );	// send 'SYNC_L'
			for( i = 0 ; i < data_len ; i++){
				for( b = 0 ; b < 8 ; b++ ){
					ir_flash( FLASH_NEC_TIMES );
					if( data[i] & (0x01 << b) ){
						ir_wait( 3 * FLASH_NEC_TIMES );
					}else{
						ir_wait( FLASH_NEC_TIMES );
					}
				}
			}
			ir_flash( FLASH_NEC_TIMES );		// send 'stop'
			break;
		case SIRC:
			for(j=0;j<3;j++){
				t=5;						// MσV{{P(SYNCőM)
				ir_flash( 4 * FLASH_SIRC_TIMES );	// send 'SYNC_H'
				ir_wait(      FLASH_SIRC_TIMES );	// send 'SYNC_L'

				for( i = 0 ; i < data_len ; i++){
					for( b = 0 ; b < 8 ; b++ ){
						if( data[i] & (0x01 << b) ){
							ir_flash( 2 * FLASH_SIRC_TIMES );
							t +=3 ;
						}else{
							ir_flash( FLASH_SIRC_TIMES );
							t +=2 ;
						}
						ir_wait( FLASH_SIRC_TIMES );
					}
				}
				while( t <= 75 ){
					t++;
					ir_wait( FLASH_SIRC_TIMES );
				}
			}
			break;
		case AEHA:
		default:
			ir_flash( 8 * FLASH_AEHA_TIMES );	// send 'SYNC_H'
			ir_wait(  4 * FLASH_AEHA_TIMES);	// send 'SYNC_L'
			for( i = 0 ; i < data_len ; i++){
				for( b = 0 ; b < 8 ; b++ ){
					ir_flash( FLASH_AEHA_TIMES );
					if( data[i] & (0x01 << b) ){
						ir_wait( 3 * FLASH_AEHA_TIMES );
					}else{
						ir_wait( FLASH_AEHA_TIMES );
					}
				}
			}
			ir_flash( FLASH_AEHA_TIMES );		// send 'stop'
			break;
	}
}

void main(){
	byte i,j;
	byte data[DATA_SIZE];
	byte len = 0;
	byte c;
	enum IR_TYPE ir_type;
	
	init_io();
	init_t0();
	IR_OUT = IR_OUT_OFF;
	scif_init();						// VA
	
	puts("hello!\n");
	
	while(1){
		c = getch();
		LED = LED_ON;
		if( c == 0x1B){			// GXP[v(27)
			c = getch();
			if( c == (byte)'I' ){
				c = getch();
				if( c == (byte)'R' ){
					len = getch();
					if( ( ir_type = len>>6 ) != 0b11 ){
						/*  ŎԂHƘASCIf[^MłȂ̂ */
						// len &= 0x2F;	// 2rbgtypeŉ6bitIR(bytes)
						// if( len > DATA_SIZE ) len = DATA_SIZE;
						len &= 0x0F;	// DATA_SIZE = 16p L̃\[Xȗ
						for( i = 0 ; i < len ; i++ ) data[i] = getch();
					}else {									// ( len>>6 == 3 )
						// len &= 0x0F;						// vZbgԍ
						c = len << 4;						// EEPROMAhXvZ
						ir_type = (byte)eeprom_read( c ) >> 6;	// 2rbgtype
						len = (byte)eeprom_read( c ) & 0x0F;		// 4rbglen
						if( ir_type != 3 && len != 0 ){
							for( i = 1 ; i <= len ; i++ ){
								data[i-1] = eeprom_read( c + i);	// EEPROMǂݏo
							}
						}else{
							len = 0;
							data[0] = 0;
						}
					}
					if( len > 0 ){
						ir_send( data , len , ir_type );
						switch( ir_type ){
							case AEHA:	puts("type=AEHA");	break;
							case NEC:	puts("type=NEC");	break;
							case SIRC:	puts("type=SIRC");	break;
							default:	puts("type=ERROR(AEHA)");	break;
						}
						puts(" l="); puts_hex( len ); puts(" data=");
						for( i = 0 ; i < len ; i++ ) puts_hex( data[i] );
						putch('\n');
					}
					c =0x00;
				}
			}
		}
		if( GPIO2 == 0) {
			ir_send( data , len , ir_type );
		}
		if( c > 32 || c == (byte)'\n' ) {
			putch( c );
		}
		LED = LED_OFF;
		if( PS_IN == 0 ){
			__delay_ms(50);
			if( PS_IN == 0 ) sleep_on();
		}
	}
}

// EEPROMf[^ type   len   data....
#ROM 0x2100 = { 0x00 + 0x06 ,0xAA,0x5A,0x8F,0x12,0x15,0xE1}	// AQUOS VOL_DOWN
#ROM 0x2110 = { 0x00 + 0x05 ,0x2C,0x52,0x09,0x2B,0x22};	// Lighting LEVEL_DOWN
